# EMD分解画图试用版代码
# 本程序2022.11定型，后续更新都在完整版代码中
# 本代码地址及代码说明：http://khsci.com/docs/index.php/2022/11/08/emd_py

# 注意1：首次执行代码前请确保安装PyEMD、numpy、Matplotlib包，
# 在命令行窗口执行下述指令进行安装：
# pip install EMD-signal
# pip install numpy
# pip install Matplotlib

# 注意2：此程序运行过程中会绘制图像，图像会使程序阻塞，关闭图像窗口后程序才会继续运行。

# 该画图程序主要依赖PyEMD包进行emd计算，相关文档见：https://pyemd.readthedocs.io/en/latest/

import numpy as np
import pylab as plt
from scipy.signal import hilbert
from PyEMD import EMD

import funEMD  #导入EMD画图工具包

# 1.导入数据，注意导入数据部分需要根据个人数据情况进行适应性修改

# 注意试用版数据只支持对长度为200以内的数据进行画图

dataAll = np.loadtxt("data.csv",delimiter=',')  #注意此处尽量使用np.loadtxt读取数据，使用read_csv会导致数据类型不匹配
# 示例数据dataAll中第一列为时间轴数据，第二列为待分解数据
data = dataAll[:,1]  #提取出待分析数据，需要为一维数据
t = dataAll[:,0]     #时间轴数据，有些应用场景可能没有时间轴数据，则可以不用导入时间轴数据，pEMD和pEMDandFFT的第2个入口参数给定采样频率即可，如果采样频率也未知，且不需做频谱分析，第2个入口参数可以赋值为1

# 2.调用函数实现EMD分解
imf = funEMD.kEMD(data)   #本函数不画图，只进行emd分解

# 3.调用函数实现EMD分解，并绘制时域分解图
imf = funEMD.pEMD(data,t)  #此处演示了第2个入口参数使用时间轴数据的方式

# 4.调用函数实现EMD分解，并绘制时域分解图和对应频谱图
fs = 100
imf = funEMD.pEMDandFFT(data,fs)  #此处演示了第2个入口参数使用采样频率的方式，当然这里使用时间轴数据也是可以的

# end.将分解结果写入csv文件
np.savetxt('imf.csv',imf,delimiter=',')  #delimiter用于指定分隔符


# 关于完整版代码：
# 公开版代码的函数文件为pyd文件，可以被调用，但无法查看代码。
# 完整版代码中全部为py文件，py文件可以查看源码并自由修改，无数据长度限制，可以导出预测结果，画图无水印
# 如果需要funEMD文件夹中封装好的函数的源码，可在下述连接（完整版）获取：
# http://khsci.com/docs/index.php/2022/11/08/emd_py
# 编程不易，感谢支持~
